(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common'], factory) :
	(factory((global['angular-bmap'] = {}),global.core,global.common));
}(this, (function (exports,core,common) { 'use strict';

var BMAP_CONFIG = new core.InjectionToken('bmap.config');
// export const HERO_DI_CONFIG: BMapConfig = {
//     apiEndpoint: 'api.heroes.com',
//     title: 'Dependency Injection'
// };

/**
 *
 */
function getScript(url) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = url;
    document.body.appendChild(script);
}

var CALL_BACK = "__bmap_loaded_callback__";
var UNDEFINED = "undefined";
function BMap_defined() {
    return UNDEFINED !== typeof BMap;
}
var BMapLoaderService = /** @class */ (function () {
    function BMapLoaderService(config) {
        this.config = config;
    }
    BMapLoaderService.prototype.load = function () {
        var _this = this;
        return new Promise((function (resolve, reject) {
            if (BMap_defined()) {
                resolve();
            }
            else {
                window[CALL_BACK] = function () {
                    if (BMap_defined()) {
                        resolve();
                    }
                    else {
                        reject(new Error("加载百度地图失败"));
                    }
                    delete window[CALL_BACK];
                };
                var URL_1 = "http://api.map.baidu.com/api?v=2.0&ak=" + _this.config.accessKey + "&callback=" + CALL_BACK;
                getScript(URL_1);
            }
        }));
    };
    BMapLoaderService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BMapLoaderService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [BMAP_CONFIG,] },] },
    ]; };
    return BMapLoaderService;
}());

var BMapDirective = /** @class */ (function () {
    function BMapDirective(elementRef, loader, zone) {
        this.elementRef = elementRef;
        this.loader = loader;
        this.zone = zone;
    }
    BMapDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.loader.load().then(function () {
            var map = _this.map = _this.zone.runOutsideAngular(function () {
                return new BMap.Map(_this.elementRef.nativeElement, {
                    enableMapClick: false
                });
            });
        });
    };
    BMapDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[bmap]',
                },] },
    ];
    /** @nocollapse */
    BMapDirective.ctorParameters = function () { return [
        { type: core.ElementRef, },
        { type: BMapLoaderService, },
        { type: core.NgZone, },
    ]; };
    BMapDirective.propDecorators = {
        'center': [{ type: core.Input },],
        'zoom': [{ type: core.Input },],
    };
    return BMapDirective;
}());

var BMapModule = /** @class */ (function () {
    function BMapModule() {
    }
    BMapModule.forRoot = function (config) {
        return {
            ngModule: BMapModule,
            providers: [
                { provide: BMAP_CONFIG, useValue: config }
            ]
        };
    };
    BMapModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [BMapDirective],
                    imports: [common.CommonModule],
                    exports: [BMapDirective],
                    providers: [BMapLoaderService],
                },] },
    ];
    /** @nocollapse */
    BMapModule.ctorParameters = function () { return []; };
    return BMapModule;
}());

exports.BMAP_CONFIG = BMAP_CONFIG;
exports.BMapLoaderService = BMapLoaderService;
exports.BMapDirective = BMapDirective;
exports.BMapModule = BMapModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
