import { BMAP_CONFIG } from './bmap-config';
import { Injectable, Inject } from '@angular/core';
import { getScript } from '../core/util/get-script';
var CALL_BACK = "__bmap_loaded_callback__";
var UNDEFINED = "undefined";
function BMap_defined() {
    return UNDEFINED !== typeof BMap;
}
var BMapLoaderService = /** @class */ (function () {
    function BMapLoaderService(config) {
        this.config = config;
    }
    BMapLoaderService.prototype.load = function () {
        var _this = this;
        return new Promise((function (resolve, reject) {
            if (BMap_defined()) {
                resolve();
            }
            else {
                window[CALL_BACK] = function () {
                    if (BMap_defined()) {
                        resolve();
                    }
                    else {
                        reject(new Error("加载百度地图失败"));
                    }
                    delete window[CALL_BACK];
                };
                var URL_1 = "http://api.map.baidu.com/api?v=2.0&ak=" + _this.config.accessKey + "&callback=" + CALL_BACK;
                getScript(URL_1);
            }
        }));
    };
    BMapLoaderService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    BMapLoaderService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [BMAP_CONFIG,] },] },
    ]; };
    return BMapLoaderService;
}());
export { BMapLoaderService };
//# sourceMappingURL=bmap-loader.service.js.map