import { BMapLoaderService } from './bmap-loader.service';
import { Directive, Input, AfterViewInit, ElementRef, NgZone } from '@angular/core';
import Point = BMap.Point;
import Map = BMap.Map;

@Directive({
    selector: '[bmap]',
})
export class BMapDirective implements AfterViewInit {

    @Input()
    center: Point;

    @Input()
    zoom: number;

    private map: Map;

    constructor(private elementRef: ElementRef,
        private loader: BMapLoaderService,
        private zone: NgZone) { }

    ngAfterViewInit(): void {
        this.loader.load().then(() => {
            const map = this.map = this.zone.runOutsideAngular(() => {
                return new BMap.Map(this.elementRef.nativeElement, {
                    enableMapClick: false
                });
            });
        });
    }

}
